/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.component.sushi


import javax.sql.DataSource;

import metridoc.utils.Assert;

import org.apache.camel.Component;
import org.apache.camel.Consumer;
import org.apache.camel.Processor;
import org.apache.camel.Producer;
import org.apache.camel.impl.DefaultEndpoint;
import org.apache.camel.impl.ProcessorEndpoint;
import org.apache.http.client.ResponseHandler;

/**
 *
 * @author Narine Ghochikyan
 *
 */
class SushiEndpoint extends DefaultEndpoint {
	def base;
	def path;
	
	public SushiEndpoint(String endpointUri, Component component){
		super(endpointUri, component);
	}
	
	@Override
	public Producer createProducer() throws Exception {
		ResponseHandler responseHandler = getCamelContext().getRegistry().lookup(path, ResponseHandler.class);
		return new ProcessorEndpoint(getEndpointUri(), getComponent(), new SushiProcessor(responseHandler:responseHandler)).createProducer();
	}

	@Override
	public Consumer createConsumer(Processor processor) throws Exception {
        return new SushiConsumer(this, processor)
	}

	@Override
	public boolean isSingleton() {
		return false;
	}

}
